// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.colorpicker;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;

import javax.faces.application.ResourceDependencies;
import javax.faces.application.ResourceDependency;
import javax.faces.component.FacesComponent;
import javax.faces.component.UIInput;
import javax.faces.component.behavior.ClientBehaviorHolder;

@FacesComponent(UIColorPicker.COMPONENT_TYPE)
@ResourceDependencies({
		@ResourceDependency(name = "jquery.js", library = "pfjs"),
		@ResourceDependency(name = "pf.no.conflicts.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.colorpicker.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.colorpicker.css", library = "css") })
public class UIColorPicker extends UIInput implements ClientBehaviorHolder {

	public static final String COMPONENT_TYPE = "net.playerfinder.jsf.components.colorpicker.UIColorPicker";
	public static final String COMPONENT_FAMILY = "net.playerfinder.jsf.components";
	public static final String DEFAULT_RENDERER = "net.playerfinder.jsf.components.colorpicker.UIColorPickerRenderer";

	private final static String DEFAULT_EVENT = "change";
	private static final Collection<String> EVENT_NAMES = Collections
			.unmodifiableCollection(Arrays.asList(DEFAULT_EVENT));

	protected enum PropertyKeys {
		mode, style, styleClass;

		String toString;

		PropertyKeys(String toString) {
			this.toString = toString;
		}

		PropertyKeys() {
		}

		public String toString() {
			return ((this.toString != null) ? this.toString : super.toString());
		}
	}

	public UIColorPicker() {
		setRendererType(DEFAULT_RENDERER);
	}

	@Override
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	@Override
	public Collection<String> getEventNames() {
		return EVENT_NAMES;
	}

	@Override
	public String getDefaultEventName() {
		return DEFAULT_EVENT;
	}

	public java.lang.String getMode() {
		return (java.lang.String) getStateHelper().eval(PropertyKeys.mode,
				"popup");
	}

	public void setMode(java.lang.String mode) {
		getStateHelper().put(PropertyKeys.mode, mode);
	}
}